---
layout: cp
title: Creation of Python tools and educational material for checking and explaining the absence of money leakage (a.k.a. inflation) in Monero.
author: DangerousFreedom
date: March 25, 2022
amount: 43.2
milestones:
  - name: MLSAG
    funds: 14.4
    done: 31 May 2022
    status: finished
  - name: CLSAG
    funds: 14.4
    done: 3 July 2022
    status: finished
  - name: Seraphis / Optimizations / Functional website delivery
    funds: 14.4
    done: 4 September 2022
    status: finished
payouts:
  - date: 2 June 2022
    amount: 14.4
  - date: 6 July 2022
    amount: 14.4
  - date: 7 September 2022
    amount: 14.4
---
## TLDR
Minimal Python tools and educational material for checking inflation in Monero.
Check the initial scratch [here](https://criptando.pythonanywhere.com/).
I would like your support to finish it :)

## What and Why ?
I will try to address the following issues:

1) Provide solid information about inflation.
    This project is highly focused on building the minimum necessary tools in Python to prove that there is no money leakage (inflation) occurring or that has occurred. Therefore, the community is welcome to use the tools provided here and also make improvement suggestions on how to answer this question in the most decisive way.

2) Educational material.
    This work also intends to convey the message that Monero is as safe or more as Bitcoin (cryptographically speaking). Therefore some educational material is provided for the layman and for someone looking to understand the code. Convincing someone about something may require different levels of explanations. This work tries to address this issue.

3) Provide more transparency and ease the fear of users and investors.
    Nobody heavily invests into something that they do not understand. This work provides more transparency and education on how the blockchain works with the focus on the inflation issue. Therefore, users would feel safer by investing and using Monero.

4) Abstraction of the C++ code and further implementations using Python.
    This work also gives more independence from the C++ code, which the great majority of people heavily relies on to verify the blockchain. If useful functions are implemented here, it could also help, in the future, other people to make different implementations like wallets and nodes in Python.

5) Overview of blockchain history focused on the inflation issue.
    Any successful project has to be able to tell its history in the most detailed way for the newcomers that did not live the events that happened in the past. Therefore, scanning the whole blockchain looking for leakages and providing some educational material with codes, some stats and insights is crucial not only for the new members but actually for anyone who wants to revisit the history.


## Who
- I would like to stay anonymous for the moment. I believe that the goal of the CCS is to fund an idea instead of a person so if I do not do the job, the CCS can fund someone else to do it in the way it was proposed here.
- I have never contributed to Monero and I actually got on-board recently although I know its existence for some years.
- I started investigating after this post on [reddit](https://www.reddit.com/r/Monero/comments/s9z67a/again_about_the_inflation/).
- I have a broad set of experiences like web design, Python coding, applied math and economics.
- I am highly motivated to work on this project as it is almost an existential question for me.
- I am pretty sure that I am capable of doing it following the proposed time schedule as I have been working in this project for the past two months already.


## About the proposal
First, I would like to thank everyone in the MRL channel for pointing me some directions. I believe that basically what needs to be done is the creation of Python scripts and educational materials in order to: check the ring signatures, check the amounts involved, check the uniqueness of key images and check the emission curve.

These tasks have to be done for the Pre-RingCT era, MLSAG and CLSAG.

As I have already done a scratch for the Pre-RingCT (v1) era (it is not ready yet but I strongly recommend you to check out the [temporary version](https://criptando.pythonanywhere.com/) to have an idea how the final product will look like), I still need to do improve the Pre-RingCT era and create the necessary material for the MLSAG and CLSAG. I also propose to create some educational material and scripts for Seraphis.

This work does not intend to end the discussion about inflation in Monero, it is quite the opposite, it looks for providing tools and educational material so people can have the same base for a serious and structured discussion about it. I do not expect to deliver the message that you should blindly trust in Monero but I expect to deliver a message which will raise the awareness on the inflation issue.

I will do my best to reply in a meaningful way the concerns of the community and I also will be constantly in touch with the developers and the ones that have much more knowledge than me (they have been really nice and kind so far) to explain the inflation issue in the best way. 

## Importance for the community
- Give some material and orientation for the ones looking to increase their understanding about the Monero blockchain with the focus on the inflation issue.
- Create Python functions (ring signature verifiers and others) to check the real data stored in the blockchain
- Give more transparency and explanation to the verification process of a transaction
- Reduce the fear of investors that do not understand how Monero can be transparent and at the same time private.



## Timeline and payouts
First delivery: Codes, nice explanation and some stats about MLSAG /
Date: End of May /
Amount: 14.4 XMR

Second delivery: Codes, nice explanation and some stats about CLSAG /
Date: End of June /
Amount: 14.4 XMR

Third delivery: More codes and explanations (Seraphis), clean website, optimizations and corrections /
Date: End of August /
Amount: 14.4 XMR

I propose to work for 18 USD per hour, 30h per week, for 16 weeks. Which means 18*30*16 = 8640 USD / 200 USD = 43.2 XMR
Total: 43.2 XMR

I will also pay for the costs to host the website and buy a meaningful domain name for the project.


## About deliveries
I will make all the content (codes, images, texts, ...) available and free to use, modify, share and do whatever you want.
As soon as I finish some task, I will make them available.

## Expiration Date
It would be nice if it get funded before 30.04.2022 so I can keep the expected timeline. Thank you very much in advance.
